-- cron：0 0 */1 * * ?
-- 任务名称：EVENT_BIG_CATEGORY_STATISTIC
-- 任务描述：事件大类统计
-- 输出数据表：t_analysis_event_trend_hour、t_analysis_event_trend_day
-- 依赖包：flink-connector-jdbc_2.11-1.14.3.jar、mysql-connector-java-8.0.21.jar

set table.exec.sink.not-null-enforcer=drop;
CREATE TABLE t_event_info(
                             oid BIGINT  NOT NULL,
                             type STRING,
                             confidence INT,
                             lng DOUBLE,
                             lat DOUBLE,
                             start_time TIMESTAMP(3),
                             end_time TIMESTAMP(3),
                             detect_time TIMESTAMP(3),
                             plate_no STRING,
                             grade INT,
                             object_type STRING,
                             category STRING,
                             source STRING,
                             event_serial_number STRING,
                             data_status STRING,
                             global_id STRING,
                             station_id INT,
                             lane_id STRING,
                             rid STRING,
                             segment_id STRING,
                             cross_id STRING,
                             ruksj TIMESTAMP(3),
                             PRIMARY KEY(oid) NOT ENFORCED
) WITH (
      'connector' = 'jdbc',
      'url' = 'jdbc:mysql://10.102.1.182:3306/holo_roadnet_jinan?characterEncoding=UTF-8',
      'table-name' = 't_event_info',
      'username' = 'root',
      'password' = 'Wanji300552'
      );

CREATE TABLE t_analysis_event (
    -- oid BIGINT  NOT NULL,
                                  event_category STRING,
                                  event_type STRING,
                                  event_number INT,
                                  statistic_time TIMESTAMP(3),
                                  window_start_time TIMESTAMP(3),
                                  window_end_time TIMESTAMP(3),
                                  granularity STRING,
                                  ratio DECIMAL(6,2),
                                  object_type STRING,
                                  cross_id STRING,
                                  rid STRING,
                                  segment_id STRING,
                                  lane_id STRING,
                                  PRIMARY KEY(cross_id,rid,segment_id,lane_id,window_start_time,event_type) NOT ENFORCED
)  WITH (
       'connector' = 'jdbc',
       'url' = 'jdbc:mysql://10.102.1.182:3306/holo_roadnet_jinan?characterEncoding=UTF-8',
       'table-name' = 't_analysis_event',
       'username' = 'root',
       'password' = 'Wanji300552'
       );


-- 大类事件小时统计
CREATE TABLE t_analysis_event_trend_hour (
                                             category STRING,
                                             number INT,
                                             window_start_time TIMESTAMP(3),
                                             window_end_time TIMESTAMP(3),
                                             granularity STRING,
                                             PRIMARY KEY(category,window_start_time) NOT ENFORCED
)  WITH (
       'connector' = 'jdbc',
       'url' = 'jdbc:mysql://10.102.1.182:3306/holo_roadnet_jinan?characterEncoding=UTF-8',
       'table-name' = 't_analysis_event_trend_hour',
       'username' = 'root',
       'password' = 'Wanji300552'
       );

insert into t_analysis_event_trend_hour(category,number,window_start_time,window_end_time,granularity)
SELECT  event_category,SUM(event_number),window_start_time,window_end_time,'1h'
FROM  t_analysis_event
WHERE granularity='1h'  and window_start_time >= TO_TIMESTAMP(date_format(window_start_time,'yyyy-MM-dd'))
GROUP BY event_category,window_start_time,window_end_time
;

-- 大类事件按天统计
CREATE TABLE t_analysis_event_trend_day (
                                            category STRING,
                                            number INT,
                                            window_start_time TIMESTAMP(3),
                                            window_end_time TIMESTAMP(3),
                                            granularity STRING,
                                            PRIMARY KEY(category,window_start_time) NOT ENFORCED
)  WITH (
       'connector' = 'jdbc',
       'url' = 'jdbc:mysql://10.102.1.182:3306/holo_roadnet_jinan?characterEncoding=UTF-8',
       'table-name' = 't_analysis_event_trend_day',
       'username' = 'root',
       'password' = 'Wanji300552'
       );
insert into t_analysis_event_trend_day(category,number,window_start_time,window_end_time,granularity)
SELECT  event_category,SUM(event_number),TO_TIMESTAMP(date_format(LOCALTIMESTAMP,'yyyy-MM-dd')),TO_TIMESTAMP(date_format(TIMESTAMPADD(DAY,1,TO_TIMESTAMP(date_format(LOCALTIMESTAMP,'yyyy-MM-dd'))),'yyyy-MM-dd')),'1d'
FROM  t_analysis_event
WHERE granularity='1h' and window_start_time >= TO_TIMESTAMP(date_format(window_start_time,'yyyy-MM-dd'))
GROUP BY event_category,date_format(window_start_time,'yyyy-MM-dd')
;