-- 全域车道指标-周期数据转存到MYSQL
-- 数据源kafka数据
CREATE TABLE source_gloabl_lane_cycle_data (
                                               `timeStamp` VARCHAR,
                                               orgCode VARCHAR,
                                               laneNum INT,
                                               eventList ARRAY<ROW<laneId VARCHAR,
                                               traffic_flow  INT,
                                               trolley_equivalent  INT,
                                               lane_flow_rate  DOUBLE,
                                               mean_v DOUBLE,
                                               vehicle_nums_ratio_mean  DOUBLE,
                                               vehicle_length_ratio_mean  DOUBLE,
                                               time_occupancy DOUBLE,
                                               static_queue_length_max DOUBLE,
                                               static_queue_length_min DOUBLE,
                                               dynamic_queue_length_max DOUBLE,
                                               dynamic_queue_length_min DOUBLE,
                                               light_green_start_queue_length DOUBLE,
                                               light_green_finish_queue_length DOUBLE,
                                               green_light_efficiency DOUBLE,
                                               lane_saturation_flow_rate INT,
                                               lane_capacity INT,
                                               lane_saturation DOUBLE,
                                               lane_no_stop_rate DOUBLE,
                                               lane_one_stop_rate DOUBLE,
                                               lane_two_stop_rate DOUBLE,
                                               lane_three_stop_rate DOUBLE>>
) WITH (
      'connector' = 'kafka', -- 使用 kafka connector
      'topic-pattern' = 'JN(.*)LanePeriodicData',  -- kafka topic
      'properties.bootstrap.servers' = '10.102.1.182:9092',  -- broker连接信息
      'properties.group.id' = 'lane_cycle_source', -- 消费kafka的group_id
      -- 'scan.startup.mode' = 'latest-offset',  -- 读取数据的位置
      'scan.startup.mode' = 'earliest-offset',
      'format' = 'json',  -- 数据源格式为 json
      'json.fail-on-missing-field' = 'true', -- 字段丢失任务不失败
      'json.ignore-parse-errors' = 'false'  -- 解析失败跳过
      ) ;

create table t_global_lane_cycle_data
(
    cross_id            VARCHAR,
    lane_id              VARCHAR,
    time_stamp       VARCHAR,
    org_code           VARCHAR,
    traffic_flow        INT,
    trolley_equivalent   INT,
    lane_flow_rate       DOUBLE,
    mean_v               DOUBLE,
    vehicle_nums_ratio_mean DOUBLE,
    vehicle_length_ratio_mean DOUBLE,
    time_occupancy       DOUBLE,
    static_queue_length_max DOUBLE,
    static_queue_length_min DOUBLE,
    dynamic_queue_length_max DOUBLE,
    dynamic_queue_length_min DOUBLE,
    light_green_start_queue_length DOUBLE,
    light_green_finish_queue_length DOUBLE,
    green_light_efficiency DOUBLE,
    lane_saturation_flow_rate INT,
    lane_capacity        INT,
    lane_saturation      DOUBLE,
    lane_no_stop_rate    DOUBLE,
    lane_one_stop_rate   DOUBLE,
    lane_two_stop_rate   DOUBLE,
    lane_three_stop_rate DOUBLE,
    ruksj TIMESTAMP(3),
    dt INT,
    primary key (cross_id, lane_id, time_stamp,dt) NOT ENFORCED
) WITH (
      'connector' = 'jdbc',
      'url' = 'jdbc:mysql://10.102.1.182:3306/holo_roadnet?characterEncoding=UTF-8',
      'table-name' = 't_global_lane_cycle_data',
      'username' = 'root',
      'password' = 'Wanji300552'
      );

create table t_base_lane_info(
                                 cross_id VARCHAR, -- 路口ID
                                 id VARCHAR -- 车道ID
) WITH (
      'connector' = 'jdbc',
      'url' = 'jdbc:mysql://10.102.1.182:3306/t_roadnetwork_suzhou_new?characterEncoding=UTF-8',
      'table-name' = 't_base_lane_info',
      'username' = 'root',
      'password' = 'Wanji300552'
      );

INSERT INTO t_global_lane_cycle_data(cross_id,time_stamp,org_code,lane_id,traffic_flow,trolley_equivalent,lane_flow_rate,mean_v,vehicle_nums_ratio_mean,vehicle_length_ratio_mean,time_occupancy,static_queue_length_max,static_queue_length_min,dynamic_queue_length_max,dynamic_queue_length_min,light_green_start_queue_length,light_green_finish_queue_length,green_light_efficiency,lane_saturation_flow_rate,lane_capacity,lane_saturation,lane_no_stop_rate,lane_one_stop_rate,lane_two_stop_rate,lane_three_stop_rate,ruksj,dt)
SELECT '',`timeStamp`,orgCode,laneId,traffic_flow,trolley_equivalent,lane_flow_rate,mean_v,vehicle_nums_ratio_mean,vehicle_length_ratio_mean,time_occupancy,static_queue_length_max,static_queue_length_min,dynamic_queue_length_max,dynamic_queue_length_min,light_green_start_queue_length,light_green_finish_queue_length,green_light_efficiency,lane_saturation_flow_rate,lane_capacity,lane_saturation,lane_no_stop_rate,lane_one_stop_rate,lane_two_stop_rate,lane_three_stop_rate,NOW(),CAST(DATE_FORMAT(CURRENT_ROW_TIMESTAMP(),'yyyyMMdd') AS INT)
FROM source_gloabl_lane_cycle_data
         CROSS JOIN  UNNEST(eventList) AS T(laneId,traffic_flow,trolley_equivalent,lane_flow_rate,mean_v,vehicle_nums_ratio_mean,vehicle_length_ratio_mean,time_occupancy,static_queue_length_max,static_queue_length_min,dynamic_queue_length_max,dynamic_queue_length_min,light_green_start_queue_length,light_green_finish_queue_length,green_light_efficiency,lane_saturation_flow_rate,lane_capacity,lane_saturation,lane_no_stop_rate,lane_one_stop_rate,lane_two_stop_rate,lane_three_stop_rate)
;