create table t_analysis_rid_lane_indicators_source
(
    cross_id VARCHAR,
    cross_name VARCHAR,
    rid VARCHAR,
    rid_dir INT,
    segment_id  VARCHAR,
    lane_id VARCHAR,
    lane_no VARCHAR,
    turn_dir_no VARCHAR,
    flow INT,
    saturation DECIMAL(6,2),
    delay_time INT,
    speed DECIMAL(6,2),
    queue_length INT,
    stop_num DECIMAL(6,2),
    once_stop_rate  DECIMAL(6,2),
    second_stop_rate DECIMAL(6,2),
    traffic_state VARCHAR,
    statistic_time TIMESTAMP(3),
    granularity VARCHAR,
    ruksj TIMESTAMP(3),
    trolley_equivalent   INT,
    lane_flow_rate  DECIMAL(6,2),
    vehicle_nums_ratio_mean  DECIMAL(6,2),
    vehicle_length_ratio_mean  DECIMAL(6,2),
    time_occupancy  DECIMAL(6,2),
    static_queue_length_max  DECIMAL(6,2),
    static_queue_length_min  DECIMAL(6,2),
    dynamic_queue_length_max  DECIMAL(6,2),
    dynamic_queue_length_min  DECIMAL(6,2),
    light_green_start_queue_length  DECIMAL(6,2),
    light_green_finish_queue_length  DECIMAL(6,2),
    green_light_efficiency  DECIMAL(6,2),
    saturation_flow_rate  INT,
    capacity  INT,
    no_stop_rate  DECIMAL(6,2),
    three_stop_rate  DECIMAL(6,2),
    window_start_time TIMESTAMP(3),
    window_end_time TIMESTAMP(3),
    dt INT
) WITH (
      'connector' = 'jdbc',
      'url' = 'jdbc:mysql://172.17.0.1:3306/holo_roadnet?rewriteBatchedStatements=true&characterEncoding=UTF-8&serverTimezone=Asia/Shanghai',
      'table-name' = 't_analysis_rid_lane_indicators',
      'username' = 'root',
      'password' = 'Wanji300552'
      );
create table t_analysis_rid_lane_indicators
(
    cross_id VARCHAR,
    cross_name VARCHAR,
    rid VARCHAR,
    rid_dir INT,
    segment_id  VARCHAR,
    lane_id VARCHAR,
    lane_no VARCHAR,
    turn_dir_no VARCHAR,
    flow INT,
    saturation DECIMAL(6,2),
    delay_time INT,
    speed DECIMAL(6,2),
    queue_length INT,
    stop_num DECIMAL(6,2),
    once_stop_rate  DECIMAL(6,2),
    second_stop_rate DECIMAL(6,2),
    traffic_state VARCHAR,
    statistic_time TIMESTAMP(3),
    granularity VARCHAR,
    ruksj TIMESTAMP(3),
    trolley_equivalent  INT,
    lane_flow_rate  DECIMAL(6,2),
    vehicle_nums_ratio_mean  DECIMAL(6,2),
    vehicle_length_ratio_mean  DECIMAL(6,2),
    time_occupancy  DECIMAL(6,2),
    static_queue_length_max  DECIMAL(6,2),
    static_queue_length_min  DECIMAL(6,2),
    dynamic_queue_length_max  DECIMAL(6,2),
    dynamic_queue_length_min  DECIMAL(6,2),
    light_green_start_queue_length  DECIMAL(6,2),
    light_green_finish_queue_length  DECIMAL(6,2),
    green_light_efficiency  DECIMAL(6,2),
    saturation_flow_rate  INT,
    capacity  INT,
    no_stop_rate  DECIMAL(6,2),
    three_stop_rate  DECIMAL(6,2),
    window_start_time TIMESTAMP(3),
    window_end_time TIMESTAMP(3),
    dt INT,
    PRIMARY KEY (rid,lane_id,granularity,window_end_time,dt) NOT ENFORCED
) WITH (
      'connector' = 'jdbc',
      'url' = 'jdbc:mysql://172.17.0.1:3306/holo_roadnet?rewriteBatchedStatements=true&characterEncoding=UTF-8&serverTimezone=Asia/Shanghai',
      'table-name' = 't_analysis_rid_lane_indicators',
      'username' = 'root',
      'password' = 'Wanji300552',
      'sink.buffer-flush.max-rows' = '0',
      'sink.buffer-flush.interval' = '1000'
      );

insert into t_analysis_rid_lane_indicators(cross_id,rid,rid_dir,lane_id,lane_no,turn_dir_no,flow,saturation,delay_time,speed,queue_length,stop_num,once_stop_rate,second_stop_rate,traffic_state,statistic_time,granularity,ruksj,trolley_equivalent,lane_flow_rate,vehicle_nums_ratio_mean,vehicle_length_ratio_mean,time_occupancy,static_queue_length_max,static_queue_length_min,dynamic_queue_length_max,dynamic_queue_length_min,light_green_start_queue_length,light_green_finish_queue_length,green_light_efficiency,saturation_flow_rate,capacity,no_stop_rate,three_stop_rate,window_start_time,window_end_time,cross_name,segment_id,dt)
SELECT
    cross_id,
    rid,
    rid_dir,
    lane_id,
    lane_no,
    turn_dir_no,
    sum(flow),
    avg(saturation),
    avg(delay_time),
    avg(speed),
    avg(queue_length),
    sum(stop_num),
    avg(once_stop_rate),
    avg(second_stop_rate),
    CAST(ROUND(AVG(CAST(traffic_state AS INT))) AS VARCHAR),
    LOCALTIMESTAMP statistic_time,
    '10m' granularity,
    LOCALTIMESTAMP ruksj,
    avg(trolley_equivalent),
    avg(lane_flow_rate),
    avg(vehicle_nums_ratio_mean),
    avg(vehicle_length_ratio_mean),
    avg(time_occupancy),
    max(static_queue_length_max),
    min(static_queue_length_min),
    max(dynamic_queue_length_max),
    min(dynamic_queue_length_min),
    avg(light_green_start_queue_length),
    avg(light_green_finish_queue_length),
    avg(green_light_efficiency),
    avg(saturation_flow_rate),
    max(capacity),
    avg(no_stop_rate),
    avg(three_stop_rate),
    TIMESTAMPADD(MINUTE,-10,TO_TIMESTAMP(DATE_FORMAT(LOCALTIMESTAMP,'yyyy-MM-dd HH:mm:00'))) window_start_time,
    LOCALTIMESTAMP window_end_time,
    cross_name,
    segment_id,
    CAST(date_format(LOCALTIMESTAMP,'yyyyMMdd') AS INT)
FROM
    t_analysis_rid_lane_indicators_source tb
WHERE granularity='5m' and  window_start_time >= TIMESTAMPADD(MINUTE,-10,TO_TIMESTAMP(DATE_FORMAT(LOCALTIMESTAMP,'yyyy-MM-dd HH:mm:00'))) and window_start_time < LOCALTIMESTAMP
GROUP BY cross_id,cross_name,rid,rid_dir,lane_id,lane_no,turn_dir_no,segment_id
;

-- 转向指标计算
create table t_analysis_rid_turn_indicators_source
(
    cross_id  VARCHAR,
    f_rid  VARCHAR,
    f_rid_dir INT,
    turn_dir_no INT,
    flow INT,
    speed DECIMAL(6,2),
    queue_length INT,
    green_usage_rate DECIMAL(6,2),
    stop_num DECIMAL(6,2),
    once_stop_rate DECIMAL(6,2),
    second_stop_rate DECIMAL(6,2),
    traffic_state  VARCHAR,
    statistic_time TIMESTAMP(3),
    granularity  VARCHAR,
    ruksj TIMESTAMP(3),
    window_start_time TIMESTAMP(3),
    window_end_time TIMESTAMP(3),
    cross_name  VARCHAR,
    three_stop_rate DECIMAL(6,2),
    no_stop_rate DECIMAL(6,2),
    trolley_equivalent INT,
    turn_flow_rate   DECIMAL(6,2),
    vehicle_nums_ratio_mean  DECIMAL(6,2),
    vehicle_length_ratio_mean DECIMAL(6,2),
    time_occupancy DECIMAL(6,2),
    static_queue_length_max DECIMAL(6,2),
    static_queue_length_min DECIMAL(6,2),
    dynamic_queue_length_max DECIMAL(6,2),
    dynamic_queue_length_min DECIMAL(6,2),
    light_green_start_queue_length DECIMAL(6,2),
    light_green_finish_queue_length DECIMAL(6,2),
    saturation_flow_rate INT,
    capacity INT,
    PRIMARY KEY (f_rid,turn_dir_no,granularity,window_end_time) NOT ENFORCED
) WITH (
      'connector' = 'jdbc',
      'url' = 'jdbc:mysql://172.17.0.1:3306/holo_roadnet?characterEncoding=UTF-8&serverTimezone=Asia/Shanghai',
      'table-name' = 't_analysis_rid_turn_indicators',
      'username' = 'root',
      'password' = 'Wanji300552'
      );
create table t_analysis_rid_turn_indicators
(
    cross_id  VARCHAR,
    f_rid  VARCHAR,
    f_rid_dir INT,
    turn_dir_no INT,
    flow INT,
    speed DECIMAL(6,2),
    queue_length INT,
    green_usage_rate DECIMAL(6,2),
    stop_num DECIMAL(6,2),
    once_stop_rate DECIMAL(6,2),
    second_stop_rate DECIMAL(6,2),
    traffic_state  VARCHAR,
    statistic_time TIMESTAMP(3),
    granularity  VARCHAR,
    ruksj TIMESTAMP(3),
    window_start_time TIMESTAMP(3),
    window_end_time TIMESTAMP(3),
    cross_name  VARCHAR,
    three_stop_rate DECIMAL(6,2),
    no_stop_rate DECIMAL(6,2),
    trolley_equivalent INT,
    turn_flow_rate   DECIMAL(6,2),
    vehicle_nums_ratio_mean  DECIMAL(6,2),
    vehicle_length_ratio_mean DECIMAL(6,2),
    time_occupancy DECIMAL(6,2),
    static_queue_length_max DECIMAL(6,2),
    static_queue_length_min DECIMAL(6,2),
    dynamic_queue_length_max DECIMAL(6,2),
    dynamic_queue_length_min DECIMAL(6,2),
    light_green_start_queue_length DECIMAL(6,2),
    light_green_finish_queue_length DECIMAL(6,2),
    saturation_flow_rate INT,
    capacity INT,
    PRIMARY KEY (f_rid,turn_dir_no,granularity,window_end_time) NOT ENFORCED
) WITH (
      'connector' = 'jdbc',
      'url' = 'jdbc:mysql://172.17.0.1:3306/holo_roadnet?characterEncoding=UTF-8&serverTimezone=Asia/Shanghai',
      'table-name' = 't_analysis_rid_turn_indicators',
      'username' = 'root',
      'password' = 'Wanji300552',
      'sink.buffer-flush.max-rows' = '0',
      'sink.buffer-flush.interval' = '1000'
      );
INSERT INTO t_analysis_rid_turn_indicators (
    cross_id,
    cross_name,
    f_rid,
    f_rid_dir,
    turn_dir_no,
    flow,
    speed,
    queue_length,
    green_usage_rate,
    stop_num,
    once_stop_rate,
    second_stop_rate,
    three_stop_rate,
    no_stop_rate,
    traffic_state,
    statistic_time,
    granularity,
    ruksj,
    window_start_time,
    window_end_time ,
    trolley_equivalent ,
    turn_flow_rate  ,
    vehicle_nums_ratio_mean  ,
    vehicle_length_ratio_mean,
    time_occupancy ,
    static_queue_length_max,
    static_queue_length_min,
    dynamic_queue_length_max,
    dynamic_queue_length_min,
    light_green_start_queue_length,
    light_green_finish_queue_length,
    saturation_flow_rate,
    capacity
)
SELECT
    tb.cross_id,
    tb.cross_name,
    tb.f_rid,
    tb.f_rid_dir,
    tb.turn_dir_no,
    SUM(flow),
    AVG( speed ),
    MAX( queue_length ),
    AVG(green_usage_rate),
    SUM(stop_num),
    AVG( once_stop_rate ),
    AVG(second_stop_rate ),
    AVG( three_stop_rate ),
    AVG(no_stop_rate ),
    CAST(ROUND(AVG(CAST(tb.traffic_state AS INT))) AS VARCHAR),
    LOCALTIMESTAMP statistic_time,
    '10m',
    LOCALTIMESTAMP ruksj,
    TIMESTAMPADD(MINUTE,-10,TO_TIMESTAMP(DATE_FORMAT(LOCALTIMESTAMP,'yyyy-MM-dd HH:mm:00'))) window_start_time,
    LOCALTIMESTAMP window_end_time,
    SUM(trolley_equivalent ),
    SUM(turn_flow_rate)  ,
    AVG(vehicle_nums_ratio_mean  ),
    AVG(vehicle_length_ratio_mean ),
    AVG(time_occupancy ),
    MAX(static_queue_length_max),
    MIN(static_queue_length_min),
    MAX(dynamic_queue_length_max),
    MIN(dynamic_queue_length_min),
    MAX(light_green_start_queue_length ),
    MAX(light_green_finish_queue_length ),
    SUM(saturation_flow_rate),
    SUM(capacity)
FROM  t_analysis_rid_turn_indicators_source tb
WHERE granularity='5m' and  window_start_time >= TIMESTAMPADD(MINUTE,-10,TO_TIMESTAMP(DATE_FORMAT(LOCALTIMESTAMP,'yyyy-MM-dd HH:mm:00'))) and window_start_time < LOCALTIMESTAMP
GROUP BY
    tb.cross_id,
    tb.cross_name,
    tb.f_rid,
    tb.f_rid_dir,
    tb.turn_dir_no
;