-- Flink CDC 参考：https://blog.csdn.net/qq_44326412/article/details/127064981

SET 'execution.checkpointing.interval' = '30s';

CREATE TABLE event_abnormal (
                                id INT,
                                eventType INT,
                                eventConfidence INT,
                                eventLongitude DOUBLE,
                                eventLatitude DOUBLE,
                                eventStartTime TIMESTAMP(3),
                                eventEndTime TIMESTAMP(3),
                                plateNo STRING,
                                eventGrade INT,
                                eventLevel INT,
                                dataStatus STRING,
                                eventSerialNumber STRING,
                                globalId STRING,
                                stationId INT,
                                lane_id STRING,
                                rid STRING,
                                segment_id STRING,
                                cross_id STRING,
                                PRIMARY KEY(id) NOT ENFORCED
) WITH (
      'connector' = 'mysql-cdc',
      'hostname' = '10.102.1.182',
      'port' = '3306',
      'username' = 'root',
      'password' = 'Wanji300552',
      'database-name' = 'main_control',
      'table-name' = 'event_abnormal'
      );

CREATE TABLE t_event_info(
                             oid BIGINT  NOT NULL,
                             type STRING,
                             confidence INT,
                             lng DOUBLE,
                             lat DOUBLE,
                             start_time TIMESTAMP(3),
                             end_time TIMESTAMP(3),
                             detect_time TIMESTAMP(3),
                             plate_no STRING,
                             grade INT,
                             object_type STRING,
                             category STRING,
                             source STRING,
                             event_serial_number STRING,
                             data_status STRING,
                             global_id STRING,
                             station_id INT,
                             lane_id STRING,
                             rid STRING,
                             segment_id STRING,
                             cross_id STRING,
                             PRIMARY KEY(oid) NOT ENFORCED
) WITH (
      'connector' = 'jdbc',
      'url' = 'jdbc:mysql://10.102.1.182:3306/holo_roadnet_jinan?characterEncoding=UTF-8',
      'table-name' = 't_event_info',
      'username' = 'root',
      'password' = 'Wanji300552',
      'driver'='com.mysql.cj.jdbc.Driver'
      );

CREATE TABLE t_config_event_category(
                                        category STRING,
                                        event_type STRING
)  WITH (
       'connector' = 'jdbc',
       'url' = 'jdbc:mysql://10.102.1.182:3306/holo_roadnet_jinan?characterEncoding=UTF-8',
       'table-name' = 't_config_event_category',
       'username' = 'root',
       'password' = 'Wanji300552',
       'driver'='com.mysql.cj.jdbc.Driver'
       );

CREATE VIEW v_event_info as
SELECT id,
       CAST(eventType AS STRING) eventType,
       eventConfidence,
       eventLongitude,
       eventLatitude,
       eventStartTime,
       eventEndTime,
       eventEndTime,
       plateNo,
       eventGrade,
       (CASE WHEN eventLevel=0 THEN '3' WHEN eventLevel=1 THEN '2' WHEN eventLevel=2 THEN '1' END) as object_type,
       (CASE WHEN eventLevel=0 THEN '3' WHEN eventLevel=1 THEN '2' WHEN eventLevel=2 THEN '1' END) as category,
       '1' AS source,
       eventSerialNumber,
       dataStatus,
       globalId,
       stationId,
       ifnull(cross_id,'null') cross_id,
       ifnull(rid,'null') rid,
       ifnull(lane_id,'null') lane_id,
       ifnull(segment_id,'null')  segment_id
FROM event_abnormal
;
INSERT INTO t_event_info(oid,type,confidence,lng,lat,start_time,end_time,detect_time,plate_no,grade,object_type,category,source,event_serial_number,data_status,global_id,station_id,cross_id,rid,lane_id,segment_id)
SELECT a.id,
       a.eventType,
       a.eventConfidence,
       a.eventLongitude,
       a.eventLatitude,
       a.eventStartTime,
       a.eventEndTime,
       a.eventEndTime,
       a.plateNo,
       a.eventGrade,
       b.category object_type,
       b.category category,
       '1' AS source,
       a.eventSerialNumber,
       a.dataStatus,
       a.globalId,
       a.stationId,
       a.cross_id,
       a.rid,
       a.lane_id,
       a.segment_id
FROM v_event_info a INNER  JOIN t_config_event_category b on a.eventType=b.event_type
;
